require 'doct/formats/open_format'

module Doct::Formats
  class Docx < OpenFormat

    def content_entry?(entry)
      return true if entry == 'word/document.xml'
      entry =~ /word\/(header|footer)\d*.xml/
    end

    def entry_render(entry, content, params)
      xml = Nokogiri::XML(content)
      orig_xml = xml.dup
      current_xml = xml
      sectpr_node = xml.xpath("w:document/w:body/w:sectPr").first
      if entry == 'word/document.xml'
        for page in params
          nodes = current_xml.xpath("w:document/w:body/*[name()!='w:sectPr']")
          nodes.xpath("//w:sdt//w:t").each do |node|
            node.content = page[node.content.to_sym].to_s
          end
          sectpr_node.before(nodes)
          if page != params.last
            sectpr_node.before("<w:p><w:r><w:br w:type='page'/></w:r></w:p>")
          end
          current_xml = orig_xml.dup
        end
      elsif not params.empty?
        xml.xpath("//w:sdt//w:t").each do |node|
          node.content = params.first[node.content.to_sym]
        end
      end
      xml.to_s
    end

    def entry_placeholders(entry, content)
      xml = Nokogiri::XML(content)
      xml.xpath("//w:sdt//w:t").collect {|node| node.content.to_s}
    end

    private

    Doct::Template::register_format(self, 'docx')
  end
end
