require 'doct/formats/open_format'

module Doct::Formats
  class Odt < OpenFormat
    def content_entries
      %w(content.xml styles.xml)
    end

    def entry_render(entry, content, params)
      xml = Nokogiri::XML(content)
      orig_xml = xml.dup
      current_xml = xml
      text_node = xml.xpath("//office:text").first
      if entry == 'content.xml'
        for page in params
          nodes = current_xml.xpath("//office:text/*")
          nodes.xpath("//text:database-display").each do |node|
            param_name = node.attributes["column-name"].to_s
            node.replace page[param_name.to_sym].to_s
          end
          text_node.add_child(nodes)
          if page != params.last
            text_node.add_child("<text:soft-page-break>")
          end
          current_xml = orig_xml.dup
        end
      elsif not params.empty?
        xml.xpath("//text:database-display").each do |node|
          param_name = node.attributes["column-name"].to_s
          node.replace params.first[param_name.to_sym].to_s
        end
      end
      xml.to_s
    end

    def entry_placeholders(entry, content)
      xml = Nokogiri::XML(content)
      xml.xpath("//text:database-display").collect { |node| node.attributes["column-name"].to_s }
    end

    Doct::Template::register_format(self, 'odt')
  end
end
