require 'doct/formats/base'
require 'zip/zip'
require 'nokogiri'
require 'fileutils'

module Doct::Formats
  class OpenFormat < Base

    def render(params)
      Zip::ZipOutputStream.write_buffer do |output|
        each_entry do |entry, file|
          file = entry_render(entry, file, params) if _content_entry?(entry)
          output.put_next_entry entry
          output.write file
        end
      end.string
    end

    def placeholders
      placeholders = []
      each_entry do |entry, file|
        placeholders += entry_placeholders(entry, file) if _content_entry?(entry)
      end
      placeholders
    end

    def content_entries
      nil
    end

    def content_entry?(entry)
      false
    end

    private

    def _content_entry?(entry)
      content_entries && content_entries.include?(entry) || content_entry?(entry)
    end

    def each_entry
      Zip::ZipInputStream.open(@template_path) do |input|
        while (entry = input.get_next_entry) do
          yield entry.name, input.read
        end
      end
    end

    def entry_placeholders(entry, xml)
      []
    end

    def entry_render(entry, xml, template)
      xml
    end
  end
end

